package com.fp.persistence.pgeneral.acco;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENESOLICITUDECREDIT*/
@Embeddable
public class TgeneSolicitudeCreditKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="SOLICITUDNUMBER", nullable=false,updatable=false)

/**
* Numero de solicitud
*/
private String solicitudnumber;

@Column(name="SOLICITUDSEQUENCE", nullable=false,updatable=false)

/**
* secuencia interna de solicitud
*/
private Integer solicitudsequence;

@Column(name="CREDITSEQUENCE", nullable=false,updatable=false)

/**
* Secuencia del credito.
*/
private Integer creditsequence;

/**Contructor por defecto*/
public TgeneSolicitudeCreditKey(){}
/**Contructor de TgeneSolicitudeCreditKey
@param pSolicitudnumber Numero de solicitud
@param pSolicitudsequence secuencia interna de solicitud
@param pCreditsequence Secuencia del credito.
*/
public TgeneSolicitudeCreditKey(String pSolicitudnumber,Integer pSolicitudsequence,Integer pCreditsequence){
 solicitudnumber=pSolicitudnumber;
 solicitudsequence=pSolicitudsequence;
 creditsequence=pCreditsequence;
}
/**Obtiene el valor de solicitudnumber
@return valor de solicitudnumber*/
public String getSolicitudnumber(){
  return solicitudnumber;
}
/**Fija el valor de solicitudnumber
@param pSolicitudnumber nuevo Valor de solicitudnumber*/
public void setSolicitudnumber(String pSolicitudnumber){
  solicitudnumber=pSolicitudnumber;
}

/**Obtiene el valor de solicitudsequence
@return valor de solicitudsequence*/
public Integer getSolicitudsequence(){
  return solicitudsequence;
}
/**Fija el valor de solicitudsequence
@param pSolicitudsequence nuevo Valor de solicitudsequence*/
public void setSolicitudsequence(Integer pSolicitudsequence){
  solicitudsequence=pSolicitudsequence;
}

/**Obtiene el valor de creditsequence
@return valor de creditsequence*/
public Integer getCreditsequence(){
  return creditsequence;
}
/**Fija el valor de creditsequence
@param pCreditsequence nuevo Valor de creditsequence*/
public void setCreditsequence(Integer pCreditsequence){
  creditsequence=pCreditsequence;
}

/**Implementación de la comparación de TgeneSolicitudeCreditKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneSolicitudeCreditKey))return false;
  TgeneSolicitudeCreditKey that = (TgeneSolicitudeCreditKey) o;
  if (this.getSolicitudnumber() == null || that.getSolicitudnumber() == null){
      return false;
  }
  if (! this.getSolicitudnumber().equals(that.getSolicitudnumber())){
    return false;
  }
  if (this.getSolicitudsequence() == null || that.getSolicitudsequence() == null){
      return false;
  }
  if (! this.getSolicitudsequence().equals(that.getSolicitudsequence())){
    return false;
  }
  if (this.getCreditsequence() == null || that.getCreditsequence() == null){
      return false;
  }
  if (! this.getCreditsequence().equals(that.getCreditsequence())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneSolicitudeCreditKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getSolicitudnumber() == null ? 0 : this.getSolicitudnumber().hashCode());
    result = result * 37 + (this.getSolicitudsequence() == null ? 0 : this.getSolicitudsequence().hashCode());
    result = result * 37 + (this.getCreditsequence() == null ? 0 : this.getCreditsequence().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
